import preprocess from "../src/main.js"

export default {
	input: "./test.js",
	output: {
		file: "out.js"
	},
	plugins: [
		preprocess({
			values: {
				"COMPTIME_STR": "'Hello, world!'",
				"COMPTIME_NUM": 2,
				"IS_TRUE": 1,
				"IS_FALSE": 0
			},
			transforms: {
				"NONPROD": (node, parent, idx) => {parent.comments = []} 
			}
		})
	]
}
